﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

public partial class CountCheckBoxList : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            // fill items in CheckBoxList
            for (int i = 1; i <= 20; i++)
            {
                ListItem li = new ListItem();
                li.Text = string.Format("Item {0}", i);
                li.Value = i.ToString();
                chkList.Items.Add(li);
            }
        }
    }

    protected void chkListChanged(object sender, EventArgs e)
    {
        // Tradidional approach: Commented out in favor of the Linq approach (below)
        //
        //int selectedItems = 0;
        //foreach (ListItem li in chkList.Items)
        //{
        //    if (li.Selected)
        //        selectedItems++;
        //}
        //if (selectedItems > 5)
        //{
        //    // throw some error message
        //    lblNoItems.Text = " Too many items selected...";
        //}

        // Building Linq query
        var total = from i in chkList.Items.Cast<ListItem>()
                    where i.Selected == true
                    select i;

        int allowedItems = 5;

        // Showing the results in the UI
        lblNoItems.Text = total.Count() <= allowedItems
            ? string.Format("No. of selected items: {0}. You're OK!", total.Count())
            : string.Format("To many items selected ({0}), please deselect {1} item(s)!",
                total.Count(), (total.Count() - allowedItems));
    }
}
